f 0 0 1  = 1
f 1 0 1  = 1
f 0 1 1  = 1
f _ _ 1  = 0
f 0 0 15 = 5768
f 0 1 15 = 3136
f 0 2 15 = 1705
f 1 0 15 = 54736
f 1 1 15 = 27820
f 1 2 15 = 14071
f m n k 
  | m < 0 || n < 0 = 0
  | n == 0 = sum [f (m-1) j (k-1) + f m j (k-1) | j <- [0..2]]
  | otherwise = f m (n-1) (k-1)

g 1 = 3
g k = sum $ g (k-1) : [f 0 j (k-1) | j <- [0..2]]
  ++ [f i j (k-1) | i <- [0,1], j <- [0,1]]

main = let n = 30 in print $ g n

